//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this sample source code is subject to the terms of the Microsoft
// license agreement under which you licensed this sample source code. If
// you did not accept the terms of the license agreement, you are not
// authorized to use this sample source code. For the terms of the license,
// please see the license agreement between you and Microsoft or, if applicable,
// see the LICENSE.RTF on your install media or the root of your tools installation.
// THE SAMPLE SOURCE CODE IS PROVIDED "AS IS", WITH NO WARRANTIES.
//
var G_ErrorFields = new Array();
var G_ErrorStrings = new Array();
var G_Dirty = false;
var g_CurrentPage = location.href.substring(location.href.lastIndexOf('/') + 1);

function Loc(Key)
{
	var TestLoc = false;

	if (TestLoc)
	{
		return "ABC";
	}else{
		var p = new Function("return(L_"+Key+"_Message)");
		var f = new Function("return(\"undefined\" == typeof(L_"+Key+"_Message))");

		if (true == f()) {
			alert("Undefined String: " + Key +"!")
			return "UNDEFINED STRING ["+Key+"]";
		}
		else
			return p();
	}
}

function Err(Key)
{
	var TestLoc = false;

	if (TestLoc)
	{
		return "ABC";
	}else{
		var p = new Function("return(L_"+Key+"_Error_1_Message)");
		var f = new Function("return(\"undefined\" == typeof(L_"+Key+"_Error_1_Message))");

		if (true == f()) {
			alert("Undefined String: " + Key +"!")
			return "UNDEFINED STRING ["+Key+"]";
		}
		else
			return p();
	}
}

function Menu(Key)
{
	var TestLoc = false;

	if (TestLoc)
	{
		return "ABC";
	}else{
		var p = new Function("return(L_"+Key+"_Menu_1_Message)");
		var f = new Function("return(\"undefined\" == typeof(L_"+Key+"_Menu_1_Message))");

		if (true == f()) {
			alert("Undefined String: " + Key +"!")
			return "UNDEFINED STRING ["+Key+"]";
		}
		else
			return p();
	}
}

var g_CurrentToolBarItem = "";

document.write("<link rel=stylesheet type=\"text/css\" href=\"../remoteadminimages/style.css\">");

//
//Prepare varibles as they would be generated by the ISAPI
var g_fPasswordConfigured = true;
var g_fNetworkConfigured = true;
var g_fNASConfigured = true;	


function GlobalSubmitHandler(SubOn)
{
	G_Dirty = false;
}

function ToggleMenu(Item)
{	
	var o = FindObject(Item);
	
	if(o.style.display == "block") {
		o.style.display = "none";
	} else {
		o.style.display = "block";
	}
}


var g_CurrentMenus = new Array;



var g_MenuID = 0;
function AddSelectionTab(Title)
{
	var Item = "MENUITEM_" +g_MenuID;


	document.write("<TBODY id=\"TABLE_" +g_MenuID + "\">");
	document.write("<TR><TD>");	
	//document.write("<TBODY>");
	document.write("<div class=hand_cursor onClick=ToggleMenu(\""+Item+"\")>");
	document.write("<img src=\"../remoteadminimages/images_menu_up.gif\">");
	document.write("<font class=toolbarMenuHeader>"+Title+"</font>");
	document.write("</div>");


	g_CurrentMenus[Item] = "hidden";
	document.write("<span class=hidden_menu id="+Item+">");
	document.write("</span>");
	//document.write("</table>");
	
	document.write("</TD></TR>");
	document.write("</TBODY>");


	g_MenuID ++;
	return (g_MenuID-1);
}

function GoTo(URL)
{
	try
	{
		document.location = URL;
	}
		
	catch(e)
	{
		// canceling the onbeforeunload dialog can cause the browswer to throw an "unspecified" error in document.location	
		// this protects the user from seeing it and getting confused.
		return; 
	}
}

function AddSelection(Title, URL)
{	
	document.write("<TR><TD onMouseOver=HighlightCell(this,true) onMouseOut=HighlightCell(this,false) onclick=GoTo(\""+URL+"\")>");
	document.write("<font class=toolbarHeader>"+Title+"</font>");
	document.write("</TD></TR>");
}


function AddSelectionToTab(Tab, Item, URL)
{
	var Color;
	if(URL == g_CurrentPage) {
		Color = "bgcolor=#BBBBBB";
	} else {
		Color = "onMouseOver=HighlightCell(this,true) onMouseOut=HighlightCell(this,false)";
	}

	var MyTab = FindObject("MENUITEM_"+Tab);
	var String = "<TABLE width=100%><TR><TD " + Color + " onclick=GoTo(\""+URL+"\")><font class=toolbarItem>"+Item+"</font></TD></TR></TABLE>";
	MyTab.innerHTML += String;

	if(URL == g_CurrentPage) {
		ToggleMenu("MENUITEM_"+Tab);
	}
}

function HighlightCell(o, enabled) 
{
	if(true == enabled) {
		o.bgColor = "#BBBBBB";
	} else {
		o.bgColor = "#D4D9E6";
	}
}

function AddMenuTitle(Description)
{
	document.write("<TR><TD><font class=toolbarHeader>"+Description+"</font></TD></TR>");
}

function AddBlankLine()
{
	document.write("<TR><TD><BR></TD></TR>");
}

function AddMenuItem(Enabled, Title, URL, Description)
{
	fIsClicked = false;	
	if(-1 != new String(window.location).search(URL)) {
		//fIsClicked = true;
	}

	if(!Description) {
		Description = Title;
	}
	
	if(false == fIsClicked) {		
		document.write("<TR><TD onMouseOver=HighlightCell(this,true) onMouseOut=HighlightCell(this,false)>");
		
	} else {		
		document.write("<TR><TD>");
		g_CurrentToolBarItem = Description;
	}
	if(null != URL) {
		if(false == Enabled) {
			document.write("<a href=" + URL + " class=toolbarItemNotComplete>" + Title + "</font></a>");
		} else {
			document.write("<a href=" + URL + " class=toolbarItem>" + Title + "</a>");
		}
	} else {
		if(false == Enabled) {
			document.write("<font color='YELLOW'>" + Title + "</font>");
		} else {
			document.write(Title);
		}
	}
	document.write("</TD></TR>");
}

function DisplayDirtyMsg()
{
	// onbeforeunload is an odd duck.  If you return ANYTHING (null / true / false / a string) it will turn it into 
	// a string and display it on it's cancel dialog.  If you want to abort the dialog from appearing don't "return" at all.
	
	if (G_Dirty)
		return Loc("PageDirty");
}

function BuildPage(Title, Description, MainFunction)
{
	document.write("<head>");
	document.write("<meta http-equiv='Content-Language' content='en-us'>");
	document.write("<meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>");
	document.write("<title class=pageHeadText>" + Title + "</title>");
	document.write("</head>");

	document.write("<body onbeforeunload='return(DisplayDirtyMsg())'>");
		BuildMainTable(Title, Description, MainFunction);
		AddErrorDisplay();
	document.write("</body>");
	ClearError();
}


function BuildMainTable(Title, Description, MainFunction)
{
	document.write("<table class=mainPage>");
		document.write("<TR class=TitleBar>");
			AddAttrTD("colspan=3 valign=center", Loc("WindowsCETitle"));
		EndTR();

		AddTR();
			document.write("<TD valign=top class=toolBar>");
				MakeToolBar();
				document.write("<td height=100% align=left valign=top>");
					document.write("<table class=componentContainer>");
						document.write("<TR><TD class=pageTextHeading>" + Title + "</TD></TR>");
						document.write("<TR><TD>" + Description + "</TD></TR>");
						document.write("<TR><TD>");
						if("" != MainFunction) {
								var fn = new Function(MainFunction);
								document.write("<table class=subFrame><TR><TD>");			
								fn();
								document.write("</TR></TD></table>");
   						} 
					document.write("</table>");	
				document.write("</TD>");
		    document.write("</TD>");
		document.write("</TR>");
    document.write("</table>");	
}	

function BuildMainTable_NoToolBar(Title, Description, MainFunction)
{
	document.write("<head>");
	document.write("<meta http-equiv='Content-Language' content='en-us'>");
	document.write("<meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>");
	document.write("<title class=pageHeadText>" + Title + "</title>");
	document.write("</head>");

	document.write("<body>");
	
		document.write("<table class=mainPage>");
			document.write("<TR class=TitleBar>");
				AddAttrTD("colspan=3 valign=center", Loc("WindowsCETitle"));
			EndTR();

			AddTR();
				document.write("<td height=100% align=left valign=top>");
					document.write("<table class=componentContainer>");

						document.write("<TR><TD class=pageTextHeading>" + Title + "</TD></TR>");
						document.write("<TR><TD>" + Description + "</TD></TR>");
						document.write("<TR><TD>");
					   
						if("" != MainFunction) {
 							var fn = new Function(MainFunction);
 							document.write("<TR><TD valign=top><table class=subFrame>");			
 							fn();
 							document.write("</TR></TD></table>");
 						}
					document.write("</table>");	
				document.write("</TD>");
			EndTR();

		document.write("</table>");	
	document.write("</body>");
}	

function BuildMainTable_Empty(Title, Description, MainFunction)
{
	document.write("<head>");
	document.write("<meta http-equiv='Content-Language' content='en-us'>");
	document.write("<meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>");
	document.write("<title class=pageHeadText>" + Title + "</title>");
	document.write("</head>");

	document.write("<body class=body_noHeader>");	

	document.write("<table class=subFrame>");
    document.write("<TR><TD>" + Description + "</TD></TR>");
   
    if("" != MainFunction) {
 		var fn = new Function(MainFunction);
 		document.write("<TR><TD><table class=subFrame>");			
 		fn();
 		document.write("</TR></TD></table>");
 	}

    document.write("</table>");	
	document.write("</body>");
}	


function FindObject(Name)
{
	var Obj = null;
	if("Microsoft Internet Explorer" == navigator.appName) {
		Obj = document.getElementById(Name);
	} else {
		var Sels = document.getElementsByTagName("*"); 

		for(var i=0; i<Sels.length; i++) {
			//document.write(Sels[i].id + "<BR>");
			if(Sels[i].name && Name.toUpperCase() == Sels[i].name.toUpperCase()) {				
				Obj = Sels[i];
				//alert("Found by name");
				break;
			} else if(Sels[i].id && Name.toUpperCase() == Sels[i].id.toUpperCase()) {				
				Obj = Sels[i];
				//alert("Found by id");
				break;
			}
			
		}
	}
		
	if (!Obj)
	{		
		alert("Unable to find object [" + Name + "]");
	}
	
		
	return Obj;
}

function FindSelectedRadio(Name)
{
	if(Name[0]) {
		for(var i=0; i<Name.length; i++) {
			if(true == Name[i].checked) {
				return i;
			}
		}
	} else if(true == Name.checked) {
		return 0;
	} else {
		return -1;
	}
}

function FindRadio(Name, Value) {
	if(Name[0]) {
		for(var i=0; i<Name.length; i++) {
			if(Value == Name[i].value) {
				return Name[i];
			}
		}
	} else if(Value == Name.checked) {
		return Name;
	} else {		
		return null;
	}
}

function FindAllObjectsById(Name)
{
    var Sels = document.getElementsByTagName("*");
    var Ret = new Array();
    j = 0;

    for(var i=0; i<Sels.length; i++) {
        if(Sels[i].id && 0 == String(Sels[i].id).indexOf(Name)) {
            Ret[j] = Sels[i];
            j++;
        }
    }
    return Ret;
}

function BuildBoxHeader(TableID)
{ 
	var box = "";
	
	if ("undefined" != typeof(TableID))
		TID = "ID='"+TableID+"' ";
	else
		TID = "";
	
	box += "<SPAN " + TID + ">";
	box +=  "<TABLE width=100% cellspacing=0 cellpadding=0 class=boxMain>";
	box += "<TR>";

	box +=     "<TD class=boxOutsideCorner height=5 width=5><img src=../remoteadminimages/images_corner_UL.gif></TD>";
	box +=     "<TD class=boxMiddleFiller></TD>";
	box +=     "<TD class=boxOutsideCorner height=5 width=5><img src=../remoteadminimages/images_corner_UR.gif></TD>";
	box += "</TR>";

	box += "<TR>";
	box += "<TD width=5></TD>";
	box += "<TD>";
	document.write(box);
}
function BuildBoxFooter()
{
	box = "</TD>";
	box += "<TD width=5></TD>";
	box += "</TD></TR>";

	box += "<TR>";
	box +=     "<TD class=boxOutsideCorner height=5 width=5><img src=../remoteadminimages/images_corner_LL.gif></TD>";
	box +=     "<TD class=boxMiddleFiller></TD>";
	box +=     "<TD class=boxOutsideCorner height=5 width=5><img src=../remoteadminimages/images_corner_LR.gif></TD>";
	box += "</TR>";
	box += "<TABLE><BR>";
	box += "</SPAN>";
	document.write(box);
}

function UpdateIPEditFields(o)
{	
	// before we store the new value we need to make sure everything is valid	
	baseName = o.name;

	if(baseName) {
		if(hidden = FindObject(baseName)) {
			ip1 = FindObject("IP1_"+baseName);
			ip2 = FindObject("IP2_"+baseName);
			ip3 = FindObject("IP3_"+baseName);
			ip4 = FindObject("IP4_"+baseName);
			hidden.value = ip1.value + "." +ip2.value + "." +ip3.value + "." +ip4.value; 
		} else {
			alert("ERR: Couldnt find hidden for " + baseName);
		}
	}
}

// Returns true if the field contains only numeric characters.
function isNumeric(field)
{
    if("" == field.value) {
    }
    return (field.value.match(/^\d*$/));
} 

function ValidateIPQuad(Quad)
{
	// valid quads are numeric only, with a value range of 0 - 255 inclusive
	// returns true if ok, false if any problem
	
	var valid = true;

	//check length
	if((Quad.value.length < 1) || (Quad.value.length > 3))
	{
		valid = false;
		FlagError(Quad, "IPBadLength");
		return false;
	}else{
		NoError(Quad, "IPBadLength");
	}
		
	//check char range
	if(!isNumeric(Quad)){
		valid = false;		
		FlagError(Quad, "IPNonNumeric");		
		return false;
	}else{			
		NoError(Quad, "IPNonNumeric");
	}
		
	if(parseInt(Quad.value) > 255) {
		valid = false;
		FlagError(Quad, "IPBadRange");
		return false;
	}else{
		NoError(Quad, "IPBadRange");
	}

	return valid;  
}

function BuildIPInput(IP, GlobalVar, Enabled)
{
	// Special case.  If we are disabled we could be getting "undefined" instead of a proper IP. If so set it to the empty IP "0.0.0.0"
	if ("undefined" == typeof(IP) || "" == IP)
	{	
		IP = "0.0.0.0";
	}

	ipParts = new String(IP).split(".");
	ret = "";
	
	ret += "<input type=hidden name='" + GlobalVar + "' value=" + IP + ">";
	
	var En = Enabled ? " " : "disabled";
	
	if(4 == ipParts.length) {
		ret += "<input class=normal onKeyPress=NumOnly(); onkeyup=enableApply(); onBlur=ValidateIPQuad(this); type=text " + En + " id=\"IP1_" + GlobalVar + "\" value='" + ipParts[0] + "' size=3 maxlength=3> . ";
		ret += "<input class=normal onKeyPress=NumOnly(); onkeyup=enableApply(); onBlur=ValidateIPQuad(this); type=text " + En + " id=\"IP2_" + GlobalVar + "\" value='" + ipParts[1] + "' size=3 maxlength=3> . ";
		ret += "<input class=normal onKeyPress=NumOnly(); onkeyup=enableApply(); onBlur=ValidateIPQuad(this); type=text " + En + " id=\"IP3_" + GlobalVar + "\" value='" + ipParts[2] + "' size=3 maxlength=3> . ";
		ret += "<input class=normal onKeyPress=NumOnly(); onkeyup=enableApply(); onBlur=ValidateIPQuad(this); type=text " + En + " id=\"IP4_" + GlobalVar + "\" value='" + ipParts[3] + "' size=3 maxlength=3>";
	}else{
		alert("ERR: Invalid IP: [" + IP +"] passed to BuildIPInput");
	}
	
	return ret;
}

function DisableIP(GlobalVar)
{
	var IP1 = FindObject("IP1_" + GlobalVar);
	var IP2 = FindObject("IP2_" + GlobalVar);
	var IP3 = FindObject("IP3_" + GlobalVar);
	var IP4 = FindObject("IP4_" + GlobalVar);
	IP1.disabled = true;
	IP2.disabled = true;
	IP3.disabled = true;
	IP4.disabled = true;
}

function EnableIP(GlobalVar)
{
	var IP1 = FindObject("IP1_" + GlobalVar);
	var IP2 = FindObject("IP2_" + GlobalVar);
	var IP3 = FindObject("IP3_" + GlobalVar);
	var IP4 = FindObject("IP4_" + GlobalVar);
	IP1.disabled = false;
	IP2.disabled = false;
	IP3.disabled = false;
	IP4.disabled = false;
}

function SetIP(IP, GlobalVar)
{
	// updates an already built IP segment set

	ipParts = new String(IP).split(".");

	if(4 == ipParts.length) {
		document.getElementById("IP1_" + GlobalVar).value = ipParts[0];
		document.getElementById("IP2_" + GlobalVar).value = ipParts[1];
		document.getElementById("IP3_" + GlobalVar).value = ipParts[2];
		document.getElementById("IP4_" + GlobalVar).value = ipParts[3];
	}else{
		alert("ERR: Invalid IP: [" + IP +"] passed to SetIP");
	}
}
		
function FlagIPError(GlobalVar, Err)
{
	IP = FindObject(GlobalVar);
	
	if (null == IP)
	{
		alert("ERR: Validate IP unable to locate global object ["+GlobalVar+"]");
		bVaild = false;
	}else{
	
		var IPs = new Array(4);
		for (var i=0; i < 4; i++)
		{
			IPs[i]=FindObject("IP"+(i+1)+"_" + GlobalVar);
			FlagError(IPs[i], Err);
		}
	}
}		

function ValidateIP(GlobalVar)
{
	// validates the ip parts then builds the submit variable up.
	
	var bValid = true;

	IP = FindObject(GlobalVar);
	
	if (null == IP)
	{
		alert("ERR: Validate IP unable to locate global object ["+GlobalVar+"]");
		bVaild = false;
	}else{
		var IPs = new Array(4);
		for (var i=0; i < 4; i++)
		{
			IPs[i]=FindObject("IP"+(i+1)+"_" + GlobalVar);
			
			bValid &= ValidateIPQuad(IPs[i]);
		}

		if (bValid)
		{
			// build the resulting global var up.
			IP.value = IPs[0].value + "." + IPs[1].value + "." + IPs[2].value + "." + IPs[3].value;
		}
	}

	return bValid;
}

function UpdateMACEditFields(o)
{
	baseName = new String(o.name).slice(5);
	if(baseName) {
		if(hidden = FindObject(baseName)) {
			mac1 = FindObject("MAC1_"+baseName);
			mac2 = FindObject("MAC2_"+baseName);
			mac3 = FindObject("MAC3_"+baseName);
			mac4 = FindObject("MAC4_"+baseName);
			mac5 = FindObject("MAC5_"+baseName);
			mac6 = FindObject("MAC6_"+baseName);
			hidden.value = mac1.value + " - " +mac2.value + " - " +mac3.value + " - " +mac4.value + " - " +mac5.value + " - " +mac6.value; 			
		}		
	}
}

function ValidateMACPart(Part)
{
	// valid MAC parts are 0-9 & A-F only, with a value range of 0 - FF inclusive
	// returns true if ok, false if any problem
	
	var valid = true;

    // Confirm that the field is made up of exactly two hexadecimal characters
	valid = Part.value.match(/^[0-9a-fA-F]{2}$/);

	if (valid)
	{
		NoError(Part);
		return true;
	}else{
		FlagError(Part, "MACParts");
		return false;
	}
}

function ValidateMAC(GlobalVar)
{
	// validates the MAC parts then builds the submit variable up.
	var bValid = true;

	MAC = FindObject(GlobalVar);
	
	if (null == MAC)
	{
		alert("ERR: ValidateMAC unable to locate global object ["+GlobalVar+"]");
		bVaild = false;
	}else{
		var MACs = new Array(6);
		for (var i=0; i < 6; i++)
		{
			MACs[i]=FindObject("MAC"+(i+1)+"_" + GlobalVar);
			
			bValid = ValidateMACPart(MACs[i]);
			if (!bValid)
			{
				MACs[i].select();
				MACs[i].focus();
				
				break;
			}
		}

		if (bValid)
		{
			// build the resulting global var up.
			MAC.value = MACs[0].value + "-" + MACs[1].value + "-" + MACs[2].value + "-" + MACs[3].value + "-" + MACs[4].value + "-" + MACs[5].value;
		}
	}
	return bValid;
}



function UpdateMACAddress(Mac, GlobalVal)
{
	var MACParts = new String(Mac).split("-");
	var a = FindObject("MAC1_" + GlobalVal);
	var b = FindObject("MAC2_" + GlobalVal);
	var c = FindObject("MAC3_" + GlobalVal);
	var d = FindObject("MAC4_" + GlobalVal);
	var e = FindObject("MAC5_" + GlobalVal);
	var f = FindObject("MAC6_" + GlobalVal);

	a.value = MACParts[0];
	b.value = MACParts[1];
	c.value = MACParts[2];
	d.value = MACParts[3];
	e.value = MACParts[4];
	f.value = MACParts[5];	
}

function BuildMACInput(Mac, GlobalVar, Enabled, OnKeyUp)
{
	MACParts = new String(Mac).split("-");

	if("" == OnKeyUp) {
		OnKeyUp = "enableApply()";		
	}
	ret = "";
	ret += "<input type=hidden name="+GlobalVar+" value="+Mac+">";
	if(6 == MACParts.length) {
		ret += "<input onKeyPress=HexOnly(); onkeyup="+OnKeyUp+"; onBlur=ValidateMACPart(this); type=text id=MAC1_" + GlobalVar + " value='" + MACParts[0] + "' size=1 maxlength=2> - ";
		ret += "<input onKeyPress=HexOnly(); onkeyup="+OnKeyUp+"; onBlur=ValidateMACPart(this); type=text id=MAC2_" + GlobalVar + " value='" + MACParts[1] + "' size=1 maxlength=2> - ";
		ret += "<input onKeyPress=HexOnly(); onkeyup="+OnKeyUp+"; onBlur=ValidateMACPart(this); type=text id=MAC3_" + GlobalVar + " value='" + MACParts[2] + "' size=1 maxlength=2> - ";
		ret += "<input onKeyPress=HexOnly(); onkeyup="+OnKeyUp+"; onBlur=ValidateMACPart(this); type=text id=MAC4_" + GlobalVar + " value='" + MACParts[3] + "' size=1 maxlength=2> - ";
		ret += "<input onKeyPress=HexOnly(); onkeyup="+OnKeyUp+"; onBlur=ValidateMACPart(this); type=text id=MAC5_" + GlobalVar + " value='" + MACParts[4] + "' size=1 maxlength=2> - ";
		ret += "<input onKeyPress=HexOnly(); onkeyup="+OnKeyUp+"; onBlur=ValidateMACPart(this); type=text id=MAC6_" + GlobalVar + " value='" + MACParts[5] + "' size=1 maxlength=2>";
	}else{
		alert("ERR: Invalid MAC: [" + Mac +"] passed to BuildMACInput");
	}
	return ret;
}

function ClearError()
{
	// empty the set of errors
	for (key in G_ErrorStrings)
	{
		delete G_ErrorStrings[key];
	}
	G_ErrorStrings.length = 0;

	// clears the error display field
	var ErrorVar = FindObject("ValidationErrorString");
	if (null != ErrorVar)
	{
		ErrorVar.innerHTML = "";
	}
	
	// clears error marker from all fields
	for (key in G_ErrorFields)
	{
		NoError(G_ErrorFields[key]);
	}
	
	// empty the list of errors
	G_ErrorFields.length = 0; 
}

function ClearErrorBackground(Field)
{
	Field.className = "FieldNormal";
}

function FlagError(Field, ErrMsgID)
{	
	G_ErrorFields[G_ErrorFields.length] = Field;	
	Field.className = "FieldError";

	if (null == Field.onfocus)
	{
		// Note this will only work if the field does not already have a onfocus handler.
		// But that is ok if they do they can call ClearErrorBackground in it.
		// Also once they have the handler they will keep it until the object is distroyed.
		// This is transparent if there is no error so we won't worry about clearing the handler	
	
		Field.onfocus = new Function("ClearErrorBackground(this);");
	}
	
	ShowError(Field, ErrMsgID);
}

function NoError(Field)
{
	Field.className = "FieldNormal";

	var FieldIdx = Field.name;
	if('undefined' == typeof(Field.name) || "" == Field.name) {
		FieldIdx = Field.id;
	}
	

	delete G_ErrorStrings[FieldIdx];
	
	DisplayErrorHelper();
}


function DisplayErrorHelper()
{
	var ErrorString = "";
	var DisplayErrors = new Array();

	// consolidate errors 
	for (err in G_ErrorStrings) {
		DisplayErrors[G_ErrorStrings[err]] ++;		
	}

	for(err in DisplayErrors) {
		ErrorString += err;
		ErrorString += "</BR>";
	}
	
	var ErrorVar = FindObject("ValidationErrorString");
	if (null != ErrorVar)
	{
		ErrorVar.innerHTML = ErrorString;
	}
}


function ShowError(Field, String)
{
	// First add the error to our list of errors
	var FieldIdx = Field.name;
	if('undefined' == typeof(Field.name) || "" == Field.name) {
		FieldIdx = Field.id;
	}
		
	G_ErrorStrings[FieldIdx] = Err(String);

	DisplayErrorHelper();
}

function AddErrorDisplay()
{	
	document.write("<BR><DIV class=ErrorText ID=ValidationErrorString></DIV>");
}

function FindParentForm(obj)
{
	if (null == obj)
		return null;
		
	if ("FORM" == obj.tagName)
		return obj;

	return FindParentForm(obj.parentElement);
}

function FindFormReset(btn)
{
	ClearError();
	G_Dirty	= false;

	ParentForm = FindParentForm(btn);
	if (null != ParentForm)
	{
		ParentForm.reset();
	
		var btn = FindObject("Apply");
		if (null != btn)
			btn.disabled = true;

		btn = FindObject("Cancel");
		if (null != btn)
			btn.disabled = true;
	}
}

function AddApplyCancel(FormName)
{
	if ("undefined" == typeof(FormName))
	{
		document.write("<input type=submit id=Apply value=" + Loc('BTNApply') + " disabled>  <input id=Cancel type=button disabled value=" + Loc('BTNCancel') + " onclick=FindFormReset(this)>");
	} else{
		document.write("<input type=submit id=Apply value=" + Loc('BTNApply') + " disabled>  <input id=Cancel type=button disabled value=" + Loc('BTNCancel') + " onclick=ResetForm('" + FormName + "')>");
	}
}


function AddSection(Heading, Blurb)
{
	document.write("<TR><TD COLSPAN=2 class=cellLtColor>" + Heading + "</TD></TR>");
	document.write("<TR><TD COLSPAN=4>" + Blurb + "</TD></TR>");
}	

function AddBar()
{
	document.write("<TR><TD COLSPAN=5><HR></TD></TR>");
}

function Show(ID)
{
	var Obj = FindObject(ID);
	
	if (Obj)
	{
		Obj.style.display="block";
	}else{
		// FindObject will have shown an alert
		//alert("ERR: Show() unable to find object ["+ID+"]");
	}
}

function Hide(ID)
{
	var Obj = FindObject(ID);
	
	if (Obj)
	{		
		Obj.style.display="none";
	}else{
		// FindObject will have shown an alert
		//alert("ERR: Hide() unable to find object ["+ID+"]");
	}
}

function setSelection(OptionControlID, SelValue)
{
    var OptionControl = FindObject(OptionControlID);
    var selIndex = -1;
	
	if (null == OptionControl)
	{
		alert("ERR: invalid OptionControlID '"+OptionControlID+"' passed to setSelection");
		return;
	}

    for(var i=0; i < OptionControl.options.length; i++)
    {
        if(SelValue == OptionControl.options[i].value)
        {
            selIndex = i;
        }
    }
    
    if (-1 == selIndex)
    {
		alert("ERR: Unable to find selection value [" + SelValue + "] in list [" + OptionControlID + "]");
		selIndex = 0;
	}
	
    OptionControl.selectedIndex = selIndex;
}

function AddNumericOptions(Start, End, Selected)
{
	for (var iOpt = Start; iOpt <= End; iOpt++)
	{
		Select = (Selected == iOpt) ? " SELECTED" : " ";

		document.write("<OPTION value=" + iOpt + Select + ">" + iOpt + "</OPTION>");
	}
}

function enableApply()
{
	// NOTE: If you are getting an error about "object doesn't support this property or method" then
	// you have probably got the AddApplyCancel call after the </FORM>.  This has to be inside the form
	// to work properly.
	var Apply = FindObject("Apply");
	
	if (Apply) {
		G_Dirty = true;
		
		Apply.disabled = false;
	} else{
		alert("ERR: enableApply unable to find apply button");
	}
	
	var Cancel = FindObject("Cancel");

	if (Cancel) {
		Cancel.disabled = false;
	} else{
		alert("ERR: enableApply unable to find Cancel button");
	}
}

function disableApply()
{
	// NOTE: If you are getting an error about "object doesn't support this property or method" then
	// you have probably got the AddApplyCancel call after the </FORM>.  This has to be inside the form
	// to work properly.
	var Apply = FindObject("Apply");
	
	if (Apply) {
		G_Dirty = false;
		
		Apply.disabled = true;
	} else{
		alert("ERR: enableApply unable to find apply button");
	}
	
	var Cancel = FindObject("Cancel");

	if (Cancel) {
		Cancel.disabled = true;
	} else{
		alert("ERR: enableApply unable to find Cancel button");
	}
}

function AddOptionsFromArray(Array, Selected)
{
	if (!Array)
	{
		alert("ERR: AddOptionsFromArray passed bad array");
		return;
	}
		
	for(var iOpt = 0; iOpt < Array.length; iOpt++)
	{
		var iParts = new String(Array[iOpt]).split(":");
		
		Select = (iParts[0] == Selected) ? "Selected" : " ";
		
		document.write("<OPTION value=" + iParts[0] + " " + Select + ">" + iParts[1] + "</OPTION>");
	}
}	

function AddTD(Data)
{
	document.write("<TD>" + Data + "</TD>");
}

function AddTR()
{
	document.write("<TR>");
}

function EndTR()
{
	document.write("</TR>");
}	

function AddShadow(ID, Val)
{
	var a = "<input type=hidden id=" + ID + " value='" + Val + "'>";
	document.write(a);
}

function AddAttrTD(Attribs, String)
{
	document.write("<TD " + Attribs + ">" + String + "</TD>");
}
	
function Add2ColTRTD(String1, String2)
{
	AddTR();
	document.write("<TD>" + String1 + "</TD><TD>" + String2 + "</TD>");
	EndTR();
}

function Add2ColTD(String1, String2)
{
	document.write("<TD>" + String1 + "</TD><TD>" + String2 + "</TD>");
}

function AddTRTD(String)
{
	AddTR();
		AddTD(String);
	EndTR();
}

function ResetForm(FormName)
{
	ClearError();
	
	var Form = FindObject(FormName);
	Form.reset();

	var btn = FindObject("Apply");
	btn.disabled = true;

	btn = FindObject("Cancel");
	btn.disabled = true;
	
	G_Dirty = false;
	
}

function ValidateNoneEmpty(Field, ErrMsgID, SetFocus)
{
	var valid = true;
	
	if (Field.value.length < 1)
	{
		valid = false;
		FlagError(Field, ErrMsgID);
		if (SetFocus)
		{
			Field.select();
			Field.focus();
		}
	}else{
		NoError(Field);
	}
	
	return valid;
}

function ValidatePortEmptyOK(Field, SetFocus)
{
	var valid = true;
	
    if(!isNumeric(Field))
    {
		FlagError(Field, "PortNonNumeric");
		valid = false;
    }

	// Check the range (ports must be within 0 to 65535, and the range must be nondecreasing).
	if(parseInt(Field.value) < 0 || parseInt(Field.value) > 65535)
	{
		FlagError(Field, "PortBadRange");
		valid = false;
	}

	if (valid)
	{
		NoError(Field);
	}else{
		if (SetFocus)
		{
			Field.select();
			Field.focus();
		}
	}
	
	return valid;
}

function ValidatePort(Field, SetFocus)
{
	var valid = true;
	
    valid &= ValidatePortEmptyOK(Field, SetFocus);

	if (!Field.value.length)
	{
		FlagError(Field, "PortEmpty");
		valid = false;
    }
    
   	if (valid)
	{
		NoError(Field);
	}else{
		if (SetFocus)
		{
			Field.select();
			Field.focus();
		}
	}
	
    return valid;
}

function ValidatePW(PW, MinLen, MaxLen)
{
	var valid = true;
	
	if (PW.value.length < MinLen || PW.value.length > MaxLen)
	{
		FlagError(PW, "BadPW");
		valid = false;
	}else{
		NoError(PW);
	}
	
	return valid;
}

function FocusFirstError()
{
	if (G_ErrorFields.length > 0)
	{
		Field = G_ErrorFields[0];			
		Field.select();
		Field.focus();		
	}		
}

function ValidateNotBroadcast(GlobalVar)
{
	IP = FindObject(GlobalVar);
	
	if ("0.0.0.0" == IP.value || "255.255.255.255" == IP.value)
	{
		FlagIPError(GlobalVar, "BroadcastIP");
		return false;
	}else{
		return true;
	}
}


function ValidateHostName(Name)
{
	HostName = FindObject(Name);	
	var myMatch = HostName.value;
	var fBad = false;

	if(!myMatch.match("^[a-zA-Z0-9-_]+$")) {
		fBad = true;
	}

	if(myMatch.charAt(0) == '_' || myMatch.charAt(0) == '-') {
		fBad = true;
	}
	if(!myMatch.length || myMatch.charAt(myMatch.length-1) == '_' || myMatch.charAt(myMatch.length-1) == '-') {
		fBad = true;
	}
	
	if ("" == HostName.value || HostName.value.length > 15 || fBad) {
		FlagError(HostName, "SSIDBad");
		return false;
	} else {
		return true;
	}
}

function ValidateNotNetworkID(GlobalVar)
{
	IP = FindObject(GlobalVar);
	IPParts = IP.value.split('.');

	if ("0" == IPParts[3] || "255" == IPParts[3])
	{
		FlagIPError(GlobalVar, "NetworkID");
		return false;
	}else{
		return true;
	}
}
	


var _Tab		= 9;
var _BackSpace	= 8;
var _Del		= 46;
var _CR			= 13;
var _Left		= 37;
var _Right		= 39;
var _Home		= 36;
var _End		= 35;

function HandleKey(AllowedSet)
{
	if (navigator.appName == 'Netscape') {
	    return;
	}

	var KeyCode = event.keyCode;
	var Char = String.fromCharCode(KeyCode);
	
	event.returnValue = false;

	// special chars that are always allowed
	if (KeyCode == _BackSpace	||		
		KeyCode == _CR			||
		KeyCode == _Left		||
		KeyCode == _Right		||
		KeyCode == _Home		||
		KeyCode == _End			||
		KeyCode == _Tab)
	{
		event.returnValue = true;
		return;
	}
	
	var pos = AllowedSet.indexOf(Char);

	if (AllowedSet.indexOf(Char) != -1)
	{
		event.returnValue = true;
	}else{
		event.returnValue = false;
	}
}


function NumOnly()
{
	return HandleKey("0123456789");
}

function HexOnly()
{
	return HandleKey("0123456789abcdefABCDEF");
}

function NumRangesOnly()
{
	return HandleKey("0123456789,- ");
}
	
function AddSelectionRadio(RadioSetID, Text, Value, Checked, Callback)
{
	var selected = "";
	var CB = "";

	if (Checked == Value)
	{		
		selected = "checked";
	}
	
	if ("undefined" != typeof(Callback))
	{
		CB = "onclick='" + Callback + "(this);'";
	}
		
	document.write("<TR><TD><input type=radio value='"+Value+"' name='"+RadioSetID+"' + "+selected+" "+CB+" >" + Text + "</TD></TR>");
}



function AddDOWOptions(Selected)
{
	var DaysOfWeek = new Array(Loc("Sun"), Loc("Mon"), Loc("Tue"), Loc("Wed"), Loc("Thr"), Loc("Fri"), Loc("Sat"));

	for (var iDay = 0; iDay < DaysOfWeek.length; iDay++)
	{
		Select = (Selected == iDay) ? " SELECTED" : " ";

		document.write("<OPTION value=" + iDay + Select + ">" + DaysOfWeek[iDay] + "</OPTION>");
	}
}

function FormatHour(Hour, TwentyFourHourFormat)
{
	if (TwentyFourHourFormat)
	{
		// easy
		Format = Hour + ":00";
	}else{
		var pm = (Hour > 11);
		Hour = (Hour % 12);
		
		if (0 == Hour)
			Hour = 12;
		
		Format =  Hour + ":00 ";
		if (pm)
		{
			Format += Loc("PM");
		}else{
			Format += Loc("AM");
		}
	}
	
	return Format;
}


function AddAMPMHourOptions()
{
	var hour = 0;
	var i = 0;
	for (i=0; i < 24; i++)
	{
		hour = (i % 12);
		
		if (0 == hour)
			hour = 12;

		document.write("<OPTION value=" + i + ">" + hour + ":00 ");

		if (i < 12)
		{
			document.write(Loc('AM'));
		}else{
			document.write(Loc('PM'));
		}
		document.write("</OPTION>");
	}
}
	

function ExtractDayStart(MaskedDays)
{
	// Incoming bit mask Sunday == 0x1, Monday = 0x2, Tuesday = 0x4 etc.;
	// When returning the DOW Sun = 0; mon = 1; tue=2; Wed = 3, ...
	var Gaped = false;
	var iStart = 0;

	// Need to check and see if this mask is wraping the weekend
	if ((MaskedDays & 1) && MaskedDays & (1 << 6))
	{
		// Sun & Sat both set.  If there are any gaps then we are wrapping

		iStart = 6;	// (Sat)
		for (var iShift = 5; iShift > 0; iShift--)
		{
			if ((1 << iShift) & MaskedDays)
			{
				iStart = iShift;
			}else{
				Gaped = true;
				break;
			}
		}
	}
	
	if (!Gaped)
	{
		// Isn't crossing the weekend

		for (var iShift = 0; iShift < 7; iShift++)
		{
			if ((1 << iShift) & MaskedDays)
			{
				iStart = iShift;
				break;
			}
		}
	}
	return iStart;
}

function ExtractDayEnd(MaskedDays)
{
	// Incoming bit mask Sunday == 0x1, Monday = 0x2, Tuesday = 0x4 etc.;
	// When returning the DOW Sun = 0; mon = 1; tue=2; Wed = 3, ...
	var Gaped = false;
	var iEnd = 0;

	// Need to check and see if this mask is wraping the weekend
	if ((MaskedDays & 1) && MaskedDays & (1 << 6))
	{
		// Sun & Sat both set.  If there are any gaps then we are wrapping

		iEnd = 0;	// (Sun)
		for (var iShift = 1; iShift <6; iShift++)
		{
			if ((1 << iShift) & MaskedDays)
			{
				iEnd = iShift;
			}else{
				Gaped = true;
				break;
			}
		}
	}
	if (!Gaped)
	{
		// Isn't crossing the weekend
		for (var iShift=7; iShift > 0; iShift--)
		{
			if ((1 << iShift) & MaskedDays)
			{
				iEnd = iShift;
				break;
			}
		}
	}
	return iEnd;
}

function BuildDayMask(Start, End)
{
	var DayMask = 0;
	if (Start <= End)
	{
		// Straight range
		for (var i = Start; i <= End; i++)
			DayMask |= (1 << i);
	}else{
		// We cross the weekend, need to do this in two parts
		for (var i = 0; i <= End; i++)
			DayMask |= (1 << i);
			
		for (var i = Start; i <= 6; i++)
			DayMask |= (1 << i);
	}
	
	return DayMask;
}
			
			
		
		
		
	
	



	
function SetRadioSelect(RadioControl, SelValue)
{
    var selIndex = -1;
	
	if (null == RadioControl)
	{
		alert("ERR: invalid Radio object passed to SetRadioSelect");
		return;
	}
    for(var i=0; i < RadioControl.length; i++)
    {
        if(SelValue == RadioControl[i].value)
        {
            RadioControl[i].checked = true;
            selIndex = i;
            break;
        }
    }
    
    if (-1 == selIndex)
    {
		alert("ERR: Unable to find radio button value [" + SelValue + "] in set [" + RadioControl.name + "]");
		selIndex = 0;
	}
}

function BuildFilterString(Key)
{
	var DaysOfWeek = new Array(Loc("Sun"), Loc("Mon"), Loc("Tue"), Loc("Wed"), Loc("Thr"), Loc("Fri"), Loc("Sat"));

	var Filter = Loc("Always");

	if (l_ClientList[Key][_DayStart] || l_ClientList[Key][_DayEnd] || l_ClientList[Key][_HourStart] || l_ClientList[Key][_HourEnd])
	{
		Filter = DaysOfWeek[l_ClientList[Key][_DayStart]] + "-" +
				 DaysOfWeek[l_ClientList[Key][_DayEnd]] + " " +
				 FormatHour(l_ClientList[Key][_HourStart], false) + "-" +
				 FormatHour(l_ClientList[Key][_HourEnd], false);
	}

	return Filter;
}

function SetCookie(sName, sValue)
{
	// create a session based cookie.  Will last until they close IE
	document.cookie = sName + "=" + escape(sValue);
}

function GetCookie(sName)
{
	var aCookie = document.cookie.split("; ");
	for (var i=0; i < aCookie.length; i++)
	{
		var aCrumb = aCookie[i].split("=");
		if (sName == aCrumb[0]) 
			return unescape(aCrumb[1]);
	}

  return null;
}

function AddSubmitItem(FormVar, ItemName, ItemValue)
{
	// Some browswers don't support a fully defined element in the CreateElement call.
	var NewElement = document.createElement("input");

	NewElement.setAttribute("type", "hidden");
	NewElement.setAttribute("name", ItemName);
	NewElement.setAttribute("value", ItemValue);

	FormVar.appendChild(NewElement);
}

function GetRadioValue(RS)
{
	for (var i = 0; "undefined" != typeof(RS[i]) ;i++)
	{
		if (RS[i].checked)
			return RS[i].value;
	}
	
	return "0";
}


// SIG // Begin signature block
// SIG // MIIbGgYJKoZIhvcNAQcCoIIbCzCCGwcCAQExCzAJBgUr
// SIG // DgMCGgUAMGcGCisGAQQBgjcCAQSgWTBXMDIGCisGAQQB
// SIG // gjcCAR4wJAIBAQQQEODJBs441BGiowAQS9NQkAIBAAIB
// SIG // AAIBAAIBAAIBADAhMAkGBSsOAwIaBQAEFBBeT33isq7O
// SIG // ue4Gdei9fZRwHPzRoIIV3zCCA8QwggMtoAMCAQICEEe/
// SIG // GZXfjVJGQ/fbbUgNMaQwDQYJKoZIhvcNAQEFBQAwgYsx
// SIG // CzAJBgNVBAYTAlpBMRUwEwYDVQQIEwxXZXN0ZXJuIENh
// SIG // cGUxFDASBgNVBAcTC0R1cmJhbnZpbGxlMQ8wDQYDVQQK
// SIG // EwZUaGF3dGUxHTAbBgNVBAsTFFRoYXd0ZSBDZXJ0aWZp
// SIG // Y2F0aW9uMR8wHQYDVQQDExZUaGF3dGUgVGltZXN0YW1w
// SIG // aW5nIENBMB4XDTAzMTIwNDAwMDAwMFoXDTEzMTIwMzIz
// SIG // NTk1OVowUzELMAkGA1UEBhMCVVMxFzAVBgNVBAoTDlZl
// SIG // cmlTaWduLCBJbmMuMSswKQYDVQQDEyJWZXJpU2lnbiBU
// SIG // aW1lIFN0YW1waW5nIFNlcnZpY2VzIENBMIIBIjANBgkq
// SIG // hkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAqcqypMzNIK8K
// SIG // fYmsh3XwtE7x38EPv2dhvaNkHNq7+cozq4QwiVh+jNtr
// SIG // 3TaeD7/R7Hjyd6Z+bzy/k68Numj0bJTKvVItq0g99bbV
// SIG // XV8bAp/6L2sepPejmqYayALhf0xS4w5g7EAcfrkN3j/H
// SIG // tN+HvV96ajEuA5mBE6hHIM4xcw1XLc14NDOVEpkSud5o
// SIG // L6rm48KKjCrDiyGHZr2DWFdvdb88qiaHXcoQFTyfhOpU
// SIG // wQpuxP7FSt25BxGXInzbPifRHnjsnzHJ8eYiGdvEs0dD
// SIG // mhpfoB6Q5F717nzxfatiAY/1TQve0CJWqJXNroh2ru66
// SIG // DfPkTdmg+2igrhQ7s4fBuwIDAQABo4HbMIHYMDQGCCsG
// SIG // AQUFBwEBBCgwJjAkBggrBgEFBQcwAYYYaHR0cDovL29j
// SIG // c3AudmVyaXNpZ24uY29tMBIGA1UdEwEB/wQIMAYBAf8C
// SIG // AQAwQQYDVR0fBDowODA2oDSgMoYwaHR0cDovL2NybC52
// SIG // ZXJpc2lnbi5jb20vVGhhd3RlVGltZXN0YW1waW5nQ0Eu
// SIG // Y3JsMBMGA1UdJQQMMAoGCCsGAQUFBwMIMA4GA1UdDwEB
// SIG // /wQEAwIBBjAkBgNVHREEHTAbpBkwFzEVMBMGA1UEAxMM
// SIG // VFNBMjA0OC0xLTUzMA0GCSqGSIb3DQEBBQUAA4GBAEpr
// SIG // +epYwkQcMYl5mSuWv4KsAdYcTM2wilhu3wgpo17IypMT
// SIG // 5wRSDe9HJy8AOLDkyZNOmtQiYhX3PzchT3AxgPGLOIez
// SIG // 6OiXAP7PVZZOJNKpJ056rrdhQfMqzufJ2V7duyuFPrWd
// SIG // tdnhV/++tMV+9c8MnvCX/ivTO1IbGzgn9z9KMIID/zCC
// SIG // AuegAwIBAgIQDekr8NTYKYgYMgUJXpp2iDANBgkqhkiG
// SIG // 9w0BAQUFADBTMQswCQYDVQQGEwJVUzEXMBUGA1UEChMO
// SIG // VmVyaVNpZ24sIEluYy4xKzApBgNVBAMTIlZlcmlTaWdu
// SIG // IFRpbWUgU3RhbXBpbmcgU2VydmljZXMgQ0EwHhcNMDMx
// SIG // MjA0MDAwMDAwWhcNMDgxMjAzMjM1OTU5WjBXMQswCQYD
// SIG // VQQGEwJVUzEXMBUGA1UEChMOVmVyaVNpZ24sIEluYy4x
// SIG // LzAtBgNVBAMTJlZlcmlTaWduIFRpbWUgU3RhbXBpbmcg
// SIG // U2VydmljZXMgU2lnbmVyMIIBIjANBgkqhkiG9w0BAQEF
// SIG // AAOCAQ8AMIIBCgKCAQEAslAoSN3TaHqEGERmdV1+xLif
// SIG // Yyb/PUOcfBE4ECVVc9l1J2n9TrkgXNMK+aAbKu1VViFh
// SIG // 2B7b5Lwza8fv3aM3ZY4bkwy2Ux5cfGY1XwWKRf52Tt9T
// SIG // gKKBIJ2uiFyiCPflMPnuIjdMQgrO38YfxNZV6YE/tVKj
// SIG // LKoBevKiqo01/p/mXWoFnz1r47+WwP7MYPlA5wegROuB
// SIG // UW6lKvK2ihAo7Y/cBqCGUJp7SggNMB3KEJ5r9+lYrgSp
// SIG // QJmyKOiPFqw841NvS9M1nbVvZB2zliy7Ped56216+Rbm
// SIG // Jq2v75lTt0Aslbh5qv7UUqspdH5C7DkeomoW5lm7JGjY
// SIG // AIBDEIeAawIDAQABo4HKMIHHMDQGCCsGAQUFBwEBBCgw
// SIG // JjAkBggrBgEFBQcwAYYYaHR0cDovL29jc3AudmVyaXNp
// SIG // Z24uY29tMAwGA1UdEwEB/wQCMAAwMwYDVR0fBCwwKjAo
// SIG // oCagJIYiaHR0cDovL2NybC52ZXJpc2lnbi5jb20vdHNz
// SIG // LWNhLmNybDAWBgNVHSUBAf8EDDAKBggrBgEFBQcDCDAO
// SIG // BgNVHQ8BAf8EBAMCBsAwJAYDVR0RBB0wG6QZMBcxFTAT
// SIG // BgNVBAMTDFRTQTIwNDgtMS01NDANBgkqhkiG9w0BAQUF
// SIG // AAOCAQEAh3hw2k5SASBb4HnJgjDE/bkZlr2RAMO9zc3G
// SIG // 9A7Y//lNwDNiMBHF9XQb1JLeX5wgE7F8Rb5QzYPngBeD
// SIG // pyeTZxNG+8q4mEEDzJtRWwWLf6hv8xtQGyQu8mmNbCL3
// SIG // u8oWle0MdMBod9nrmWKHwXOQ+Il0eiOro5h7l7H3jylx
// SIG // TS51G0hB2vC1DSBU1negl4Jjaf0Jz4rwdbsJm9n5EVUm
// SIG // mmEyvnoCsHuGvqLDiyIseNE1drySc1z5ueZMFQojzOTS
// SIG // 1DQuSUAVPA9geiTGpWbvls9w6z7n9A1+3NF8o3ZxacGc
// SIG // T0cwNSGxoq8aYjwr2Y6qKgd72BizXHvinaVv/jyJrTCC
// SIG // BBIwggL6oAMCAQICDwDBAIs8PIgR0T72Y+zfQDANBgkq
// SIG // hkiG9w0BAQQFADBwMSswKQYDVQQLEyJDb3B5cmlnaHQg
// SIG // KGMpIDE5OTcgTWljcm9zb2Z0IENvcnAuMR4wHAYDVQQL
// SIG // ExVNaWNyb3NvZnQgQ29ycG9yYXRpb24xITAfBgNVBAMT
// SIG // GE1pY3Jvc29mdCBSb290IEF1dGhvcml0eTAeFw05NzAx
// SIG // MTAwNzAwMDBaFw0yMDEyMzEwNzAwMDBaMHAxKzApBgNV
// SIG // BAsTIkNvcHlyaWdodCAoYykgMTk5NyBNaWNyb3NvZnQg
// SIG // Q29ycC4xHjAcBgNVBAsTFU1pY3Jvc29mdCBDb3Jwb3Jh
// SIG // dGlvbjEhMB8GA1UEAxMYTWljcm9zb2Z0IFJvb3QgQXV0
// SIG // aG9yaXR5MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIB
// SIG // CgKCAQEAqQK9wXDmO/JOGyifl3heMOqiqY0lX/j+lUyj
// SIG // t/6doiA+fFGim6KPYDJr0UJkee6sdslU2vLrnIYcj5+E
// SIG // ZrPFa3piI9YdPN4PAZLolsS/LWaammgmmdA6LL8MtVgm
// SIG // wUbnCj44liypKDmo7EmDQuOED7uabFVhrIJ8oWAtd0zp
// SIG // mbRkO5pQHDEIJBSfqeeRKxjmPZhjFGBYBWWfHTdSh/en
// SIG // 75QCxhvTv1VFs4mAvzrsVJROrv2nem10Tq8YzJYJKCEA
// SIG // V5BgaTe7SxIHPFb/W/ukZgoIptKBVlfvtjteFoF3BNr2
// SIG // vq6Alf6wzX/WpxpyXDzKvPAIoyIwswaFybMgdxOF3wID
// SIG // AQABo4GoMIGlMIGiBgNVHQEEgZowgZeAEFvQcO9pcp4j
// SIG // UX4Usk2O/8uhcjBwMSswKQYDVQQLEyJDb3B5cmlnaHQg
// SIG // KGMpIDE5OTcgTWljcm9zb2Z0IENvcnAuMR4wHAYDVQQL
// SIG // ExVNaWNyb3NvZnQgQ29ycG9yYXRpb24xITAfBgNVBAMT
// SIG // GE1pY3Jvc29mdCBSb290IEF1dGhvcml0eYIPAMEAizw8
// SIG // iBHRPvZj7N9AMA0GCSqGSIb3DQEBBAUAA4IBAQCV6AvA
// SIG // jfOXGDXtuAEk2HcR81xgMp+eC8s+BZGIj8k65iHy8FeT
// SIG // LLWgR8hi7/zXzDs7Wqk2VGn+JG0/ycyq3gV83TGNPZ8Q
// SIG // cGq7/hJPGGnA/NBD4xFaIE/qYnuvqhnIKzclLb5loRKK
// SIG // JQ9jo/dUHPkhydYV81KsbkMyB/2CF/jlZ2wNUfa98VLH
// SIG // vefEMPwgMQmIHZUpGk3VHQKl8YDgA7Rb9LHdyFfuZUnH
// SIG // UlS2tAMoEv+Q1vAIj364l8WrNyzkeuSod+N2oADQaj/B
// SIG // 0jaK4EESqDVqG2rbNeHUHATkqEUEyFozOG5NHA1itwqi
// SIG // jNPVVD9GzRxVpnDbEjqHk3Wfp9KgMIIEwzCCA6+gAwIB
// SIG // AgIQaguZT8AAHasR2sQCoWYnujAJBgUrDgMCHQUAMHAx
// SIG // KzApBgNVBAsTIkNvcHlyaWdodCAoYykgMTk5NyBNaWNy
// SIG // b3NvZnQgQ29ycC4xHjAcBgNVBAsTFU1pY3Jvc29mdCBD
// SIG // b3Jwb3JhdGlvbjEhMB8GA1UEAxMYTWljcm9zb2Z0IFJv
// SIG // b3QgQXV0aG9yaXR5MB4XDTA2MDQwNDE3NDQxNFoXDTEy
// SIG // MDQyNjA3MDAwMFowgaYxCzAJBgNVBAYTAlVTMRMwEQYD
// SIG // VQQIEwpXYXNoaW5ndG9uMRAwDgYDVQQHEwdSZWRtb25k
// SIG // MR4wHAYDVQQKExVNaWNyb3NvZnQgQ29ycG9yYXRpb24x
// SIG // KzApBgNVBAsTIkNvcHlyaWdodCAoYykgMjAwMCBNaWNy
// SIG // b3NvZnQgQ29ycC4xIzAhBgNVBAMTGk1pY3Jvc29mdCBD
// SIG // b2RlIFNpZ25pbmcgUENBMIIBIDANBgkqhkiG9w0BAQEF
// SIG // AAOCAQ0AMIIBCAKCAQEAw8wgjbzf/z5Q7nrC1CQl9nbO
// SIG // If/NKlZOypy3grI1eS0AxKgI1WPJt6X26cHB1rGMlqIH
// SIG // +g+2glKa64LGvRDFqMDua4SOUxu7UPpkAYnBFtSCaABA
// SIG // eET1EjhO+2NR4Po9ueU3sd9jByM7cUA0R/Rrrkb1J3Me
// SIG // IstCGR5RtlKa06PQE8YZP3EGbfKVIURfQu3AyZlkILjB
// SIG // NPyiROZ7sh0vuKbe9KHfmyEP/lgxQVU4fq9Y5+TsWXkl
// SIG // q/cqLxE/OHg+Qn+naOR+ImgX5kqSxHhEUkehT4SJk5vA
// SIG // Z3vqCfuGA332mXE8K6dmmMzfLeIrAhoPNEhl9TwSr/GH
// SIG // HB0mUm/MAwIBA6OCASowggEmMBMGA1UdJQQMMAoGCCsG
// SIG // AQUFBwMDMIGiBgNVHQEEgZowgZeAEFvQcO9pcp4jUX4U
// SIG // sk2O/8uhcjBwMSswKQYDVQQLEyJDb3B5cmlnaHQgKGMp
// SIG // IDE5OTcgTWljcm9zb2Z0IENvcnAuMR4wHAYDVQQLExVN
// SIG // aWNyb3NvZnQgQ29ycG9yYXRpb24xITAfBgNVBAMTGE1p
// SIG // Y3Jvc29mdCBSb290IEF1dGhvcml0eYIPAMEAizw8iBHR
// SIG // PvZj7N9AMBIGCSsGAQQBgjcVAQQFAgMDAAQwHQYDVR0O
// SIG // BBYEFCX4K0tdyHJUreX2oCoXFvvB+VOBMBkGCSsGAQQB
// SIG // gjcUAgQMHgoAUwB1AGIAQwBBMAsGA1UdDwQEAwIBRjAP
// SIG // BgNVHRMBAf8EBTADAQH/MAkGBSsOAwIdBQADggEBAGPj
// SIG // 4PMFuLDqCws00YIxPoliRdUIp/lhZcguA/o4SEHPtfIn
// SIG // g9PjxVZTqLUZzszm8aD5VrZIlEck5akf3HrU9hZ6Etvz
// SIG // kBvsCF2zhZC5jFi7HMyV05WUM/SR3v+Im15LSVA5Jjog
// SIG // G1Q3/H1cFZPD3ByO8GFSPOUH7WbveeyPzldjZZUYSaB6
// SIG // 32W33yau/sgStsaizMZfi3Dzyturgm4H3GUZuaj2hsIJ
// SIG // QpjxJqxperHBK6ewZh+lr4cIa5cTuLA2mR4FoxM4o8Cs
// SIG // MD66IdcwpspiEhyvV43l8XoRul48DDfxk8GSiE4EWgVc
// SIG // x8/WqdnhfZF4J/u0bqWPBjNYsV4qEQ8wggUzMIIEG6AD
// SIG // AgECAgphRp7LAAQAAABlMA0GCSqGSIb3DQEBBQUAMIGm
// SIG // MQswCQYDVQQGEwJVUzETMBEGA1UECBMKV2FzaGluZ3Rv
// SIG // bjEQMA4GA1UEBxMHUmVkbW9uZDEeMBwGA1UEChMVTWlj
// SIG // cm9zb2Z0IENvcnBvcmF0aW9uMSswKQYDVQQLEyJDb3B5
// SIG // cmlnaHQgKGMpIDIwMDAgTWljcm9zb2Z0IENvcnAuMSMw
// SIG // IQYDVQQDExpNaWNyb3NvZnQgQ29kZSBTaWduaW5nIFBD
// SIG // QTAeFw0wNjA0MDQxOTQzNDZaFw0wNzEwMDQxOTUzNDZa
// SIG // MHQxCzAJBgNVBAYTAlVTMRMwEQYDVQQIEwpXYXNoaW5n
// SIG // dG9uMRAwDgYDVQQHEwdSZWRtb25kMR4wHAYDVQQKExVN
// SIG // aWNyb3NvZnQgQ29ycG9yYXRpb24xHjAcBgNVBAMTFU1p
// SIG // Y3Jvc29mdCBDb3Jwb3JhdGlvbjCCASIwDQYJKoZIhvcN
// SIG // AQEBBQADggEPADCCAQoCggEBAM2BljiuXKLywd/e0KuV
// SIG // jdY8nR+Lw12GLl3wsXL1q6yIarXasSJ7C8jIpUuRXiIT
// SIG // 6fn1I5219G52ru/upDzHxMBZXD+rs3MzJqZigWF5oWL0
// SIG // boiV0G7dx5/SpFERdmG6cIploZYWiaddgdBEZuXbVp5A
// SIG // yvzcdiQuRDAA5dZ9e5UR1Vgdo+hPC8mI3KLWU5lsymPK
// SIG // mWqakl5MTRHoL9NbW15fUqNzLaW7hEUNjBkVdssI2pqm
// SIG // cBXoTexp/V2ya4/tKVE3OIvGRkkVlFCYsPRopNfeCXFn
// SIG // dJ53jB2Fa5fq519FzODmcQ3RYwCTezGYjgu0E72z0O7x
// SIG // 3yHuqWBh7jdDPcMCAwEAAaOCAZIwggGOMA4GA1UdDwEB
// SIG // /wQEAwIGwDAdBgNVHQ4EFgQU7tlrqXVTzU/uG04ZBh6j
// SIG // nKvPlP0wEwYDVR0lBAwwCgYIKwYBBQUHAwMwgakGA1Ud
// SIG // IwSBoTCBnoAUJfgrS13IclSt5fagKhcW+8H5U4GhdKRy
// SIG // MHAxKzApBgNVBAsTIkNvcHlyaWdodCAoYykgMTk5NyBN
// SIG // aWNyb3NvZnQgQ29ycC4xHjAcBgNVBAsTFU1pY3Jvc29m
// SIG // dCBDb3Jwb3JhdGlvbjEhMB8GA1UEAxMYTWljcm9zb2Z0
// SIG // IFJvb3QgQXV0aG9yaXR5ghBqC5lPwAAdqxHaxAKhZie6
// SIG // MEsGA1UdHwREMEIwQKA+oDyGOmh0dHA6Ly9jcmwubWlj
// SIG // cm9zb2Z0LmNvbS9wa2kvY3JsL3Byb2R1Y3RzL0NvZGVT
// SIG // aWduUENBMi5jcmwwTwYIKwYBBQUHAQEEQzBBMD8GCCsG
// SIG // AQUFBzAChjNodHRwOi8vd3d3Lm1pY3Jvc29mdC5jb20v
// SIG // cGtpL2NlcnRzL0NvZGVTaWduUENBMi5jcnQwDQYJKoZI
// SIG // hvcNAQEFBQADggEBADjZ75U4m1yYFF1UbmnfAsjns/vT
// SIG // wk2tL6t/VA3aMrb4auYN+yEadz6laHq0lX6KXPJDxIOb
// SIG // ZX2IUFF8ghT1g3PXor5cygJwziZsF7xSFKWJwLfkocyh
// SIG // dZ2RcT0bwFYAVrX4hCbaXjP71iV6Xprapvv08kEarFVG
// SIG // rUjckTgTWAlJ8fMxhx+8BI5bEmUD6QtR0KEMipm92cGo
// SIG // 0AgVJSG1tleJHNFbhjWlyv2qh+ypNz+3Q2vjIPFFvH6u
// SIG // 6fFVsqFIvGW+UzTZyegGYwQGeG5Q/0i7m+pDWofbrQqA
// SIG // 9VnFLOTlf1tK5TJ57iKFkgwts1BbxsJAWFir0s3jL8HN
// SIG // 7G2fN3kxggSnMIIEowIBATCBtTCBpjELMAkGA1UEBhMC
// SIG // VVMxEzARBgNVBAgTCldhc2hpbmd0b24xEDAOBgNVBAcT
// SIG // B1JlZG1vbmQxHjAcBgNVBAoTFU1pY3Jvc29mdCBDb3Jw
// SIG // b3JhdGlvbjErMCkGA1UECxMiQ29weXJpZ2h0IChjKSAy
// SIG // MDAwIE1pY3Jvc29mdCBDb3JwLjEjMCEGA1UEAxMaTWlj
// SIG // cm9zb2Z0IENvZGUgU2lnbmluZyBQQ0ECCmFGnssABAAA
// SIG // AGUwCQYFKw4DAhoFAKCBxDAZBgkqhkiG9w0BCQMxDAYK
// SIG // KwYBBAGCNwIBBDAcBgorBgEEAYI3AgELMQ4wDAYKKwYB
// SIG // BAGCNwIBFTAjBgkqhkiG9w0BCQQxFgQUCPxTwRE6Gb6a
// SIG // SglZ7aVM/B3/xwYwZAYKKwYBBAGCNwIBDDFWMFSgNoA0
// SIG // AE0AaQBjAHIAbwBzAG8AZgB0ACAAUABsAGEAdABmAG8A
// SIG // cgBtACAAQgB1AGkAbABkAGUAcqEagBhodHRwOi8vd3d3
// SIG // Lm1pY3Jvc29mdC5jb20wDQYJKoZIhvcNAQEBBQAEggEA
// SIG // A4ZxZ3dC6TAKd9icOi0mGYxzuZmNAAty1xz0f01894hx
// SIG // MLWf+O8jeQkSY0MBo6eOIpRtIdXl9FSJyQTZFlmE1GYa
// SIG // ER3kqo3BygmHswAVrlrlH0T+CKSC2VaKeT23A/fYkmR2
// SIG // h94S8Jk+In3FknsvYs02SH8SCCVrpgpDf283GUe8r+l9
// SIG // DVAoyxzACoXLtaBFrhDEgKlD1yZOSVD6JLHpaaBptyfe
// SIG // BX4znR2hz1nNyV7DWfPwpWk8+suRiqRwLuMbigfs1o+q
// SIG // Cyj1e5faQkagok4MV5BO5ltGk0rhqJRpW0Sl1mJ68meM
// SIG // FieVzmeVmrPY6LEZOflbqPpNBSQTsNBiT6GCAf8wggH7
// SIG // BgkqhkiG9w0BCQYxggHsMIIB6AIBATBnMFMxCzAJBgNV
// SIG // BAYTAlVTMRcwFQYDVQQKEw5WZXJpU2lnbiwgSW5jLjEr
// SIG // MCkGA1UEAxMiVmVyaVNpZ24gVGltZSBTdGFtcGluZyBT
// SIG // ZXJ2aWNlcyBDQQIQDekr8NTYKYgYMgUJXpp2iDAMBggq
// SIG // hkiG9w0CBQUAoFkwGAYJKoZIhvcNAQkDMQsGCSqGSIb3
// SIG // DQEHATAcBgkqhkiG9w0BCQUxDxcNMDYwOTA3MTIwNzEx
// SIG // WjAfBgkqhkiG9w0BCQQxEgQQvU27LB0I2eKx/YeOsZgF
// SIG // YDANBgkqhkiG9w0BAQEFAASCAQCcrI0u8NxZYJgQP7Ma
// SIG // G0bABP7EEKvQUpyEuUY+qw62laYdlV5lcBH1YzoIFfSs
// SIG // gectpljPHbOfl2lr07ZwCAruDxs0e3YMehUlxfyRvp0Y
// SIG // M1qJe+Zpf7Ptq5/Scr9+AmjTDYllUaVEcyeG01uYPd2S
// SIG // V5/mTN++4tgbGdX9lmd0NMKO5093/X2tzSujfeOJFYIb
// SIG // uD24E7IGXNE3mgJ3/GFn6lKO/9cYPoqypP1J4zYroiaQ
// SIG // ptsefO2phbWIAH7TeTvYTWm/8TB/Okz8D8M9flxuj6zy
// SIG // nEVcKagqpBar73Dg7+iXrzdCBjI1SUS9rsFLUGaDHc45
// SIG // 2o2CBZlQ4JfuHBhE
// SIG // End signature block
